﻿-- The Event Handler

function SN:EventHandler(frame, event, ...)

	if event == "COMBAT_LOG_EVENT_UNFILTERED" then
		local timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceFlags2, destGUID, destName, destFlags, destFlags2 = ...
		local spellId, spellName, spellSchool, extraFlag1, extraFlag2, extraFlag3, extraFlag4 = select(12, ...)
		
		if type == "SPELL_CAST_SUCCESS" then
			--if frame == SN.F.threat then
			--	if sourceName == UnitName("player") then
			--		--Checking to see if this success was a threat spell
			--		for i, threat in pairs(SN.db.profile.threat) do
			--			if threat.class == select(2, UnitClass("player")) then
			--				SN:Debug("Spell "..i)
			--				SN:Debug(threat.class)
			--				SN:Debug(threat)
			--				--if spellId == spells.id then
			--				--	if spells.msg == true then								
			--				--		SN:Announcer(frame, nil, spellId, sourceName, destName, true)
			--				--	end
			--				--end
			--			end
			--		end
			--	end
			--else
			
			if frame == SN.F.cooldowns then
				for i, cooldown in pairs(SN.db.profile.cooldowns) do
					if spellId == cooldown.id then
						--Check to see if the cd is a personal only and also if it is enable
						if SN.db.profile.CD.raid then
							if UnitInParty(sourceName) or UnitInRaid(sourceName) or (sourceGUID == UnitGUID("player")) then
								--SN:Debug(frame.name)
								SN:CreateBar(frame, spellId, cooldown.CD, sourceName, sourceGUID, spellName)
								local bit
								if GetNumGroupMembers() > 5 and IsInRaid() then
									bit = true
								elseif GetNumGroupMembers() > 1 and not IsInRaid() then
									bit = false
								end
								SN:Announcer(frame, cooldown.CD, spellId, sourceName, destName, bit)
							end
						else
							if sourceGUID == UnitGUID("player") and cooldown.class == SN.playerClass then
								SN:CreateBar(frame, spellId, cooldown.CD, sourceName, sourceGUID, spellName)
							end
						end
					end
				end
			end
		--elseif type == "SPELL_CAST_FAILED" then
		--	--Checking to see if this success was a threat spell
		--	if frame == SN.F.threat then
		--		if (extraFlag1 == SPELL_FAILED_NOT_ON_MOUNTED) or (extraFlag1 == SPELL_FAILED_NOT_ON_SHAPESHIFT) then
		--			for i, spells in pairs(SN.db.profile.threat) do
		--				if spellId == spells.id then
		--					if spells.msg == true then
		--						SN:Announcer(frame, nil, spellId, sourceName, frame.storeMDtar, false)
		--					end
		--				end
		--			end
		--		end
		--	end
		elseif type == "SPELL_AURA_REFRESH" then
			if frame == SN.F.debuffs then
				if sourceGUID == UnitGUID("player") and destGUID ~= UnitGUID("player") and UnitGUID("target") then
					local _, _, _, _, _, dur = UnitDebuff("target", spellName)
					--Is there a bar for this debuff already?
					if DBVisible ~= nil then
						for i, bar in pairs(DBVisible) do
							if i:Get("SN:arg2") == spellId and i:Get("SN:arg3") == destGUID and i:Get("SN:arg4") == sourceName then
								i:SetDuration(dur)
								i:Start()
							end
						end
					end
				end
			end
		elseif type == "SPELL_AURA_APPLIED" then
			if frame == SN.F.debuffs then
				if sourceGUID == UnitGUID("player") and destGUID ~= UnitGUID("player") and destGUID == UnitGUID("target") then
					local name, _, _, _, _, dur = UnitDebuff("target", spellName)
					if spellName == name then
						--SN:Debug(format(spellName.." applied to "..destName.." by "..sourceName.." will last for "..dur))
						SN:CreateBar(frame, spellId, dur, sourceName, destGUID, spellName)
					end
				end
			end
		--Reset text after the Buff has been dispeled
		elseif type == "SPELL_AURA_REMOVED" then
			if frame == SN.F.dispel then
				if spellId == frame.dispelSpell then
					frame.value:SetText("")
				end
			end
			--Stop the debuff from still displaying after the target is dead
			if frame == SN.F.debuffs then
				if DBVisible ~= nil then
					for i, bar in pairs(DBVisible) do
						if i:Get("SN:arg2") == spellId and i:Get("SN:arg3") == destGUID and i:Get("SN:arg4") == sourceName then
							i:Stop()
						end
					end
				end
			end
		--Reset text after the Buff has been dispeled
		elseif type == "SPELL_DISPEL" then
			if frame == SN.F.dispel then
				if spellId == frame.dispelSpell then
					frame.value:SetText("")
				end
			end
		--Reset text after the Buff has been dispeled
		elseif type == "SPELL_AURA_STOLEN" then
			if frame == SN.F.dispel then
				if spellId == frame.dispelSpell then
					frame.value:SetText("")
				end
			end
		elseif type == "UNIT_DIED" or "UNIT_DESTROYED" then
			--Check for a wipe so we can kill the cooldown bars
			local wiped = SN:CheckForWipe()
			if wiped then
				if CDVisible ~= nil and frame == SN.F.cooldowns then
					for i, bar in pairs(CDVisible) do
						if i:Get("SN:arg7") > 299 then
							i:Stop()
						end
					end
				end
			end
		elseif  type == "SPELL_DAMAGE" then
			--Check to see if Cobra Shot or Steady Shot hit so we can refresh Serpent Sting
			if frame == SN.F.debuffs then
				if spellId == 77767 or spellId == 53209 then
					if sourceGUID == UnitGUID("player") then
						if destGUID == UnitGUID("target") then
							for i, bar in pairs(DBVisible) do
								if i:Get("SN:arg2") == spellId then
									local _, _, _, _, _, dur, expire = UnitDebuff("target", "Serpent Sting")
									local time = (expire - GetTime()) + 6
									if time > 15 then
										time = 15
									end
									i:SetDuration(time)
									i:Start()
								end
							end
						end
					end
				end	
			end
		end
	end

	if event == "SPELL_UPDATE_USABLE" then
		if frame == SN.F.cooldowns then
			for i, bar in pairs(CDVisible) do
				if i:Get("SN:arg4") == "player" then
					local _, duration, enable = GetSpellCooldown(i:Get("SN:arg2"))
					if duration == 0 then
						i:Stop()
					end
				end
			end
		end
	end

	if event == "UNIT_SPELLCAST_START" then
		if frame == SN.F.power then
			local sourceName, spellName, _, _, spellId = ...
		
			if sourceName == "player" then
				--Check to see if the focus gen spells were cast and run the Predict function					
				if spellId  == 56641 or spellId == 77767 then -- HUNTER: Steady Shot / Cobra Shot
					SN:updatePredict()
				end
			end
		end
	end
	
	--if event == "UNIT_SPELLCAST_SENT" then
	--	--Store the target name for the misdirect/tricks of the trade since the failed event doesn't have a target arg
	--	if frame == SN.F.threat then
	--		local unitID, spellId, _, target = ...
	--		if unitID == "player" then
	--			for i, spells in pairs(SN.db.profile.threat) do
	--				if spellId == GetSpellInfo(spells.id) then
	--					if spells.msg == true then
	--						frame.storeMDtar = target
	--					end
	--				end
	--			end
	--		end
	--	end
	--end

	if event == "UNIT_SPELLCAST_STOP" or event == "UNIT_SPELLCAST_FAILED" then
		if frame == SN.F.power then
			local sourceName, spellName, _, _, spellId = ...
			--The focus regen stopped or failed so shut off the prediction
			if spellId == 56641 or spellId == 77767 then -- HUNTER: Steady Shot / Cobra Shot							
				frame.predict:Hide()
			end
		end
	end
	
	--if event == "UNIT_THREAT_SITUATION_UPDATE" or event == "UNIT_THREAT_LIST_UPDATE" then
	--	local status = UnitThreatSituation("player")
	--	local _, _, threatpct, _, _ = UnitDetailedThreatSituation("player", "target")
	--	local i
			
	--	if frame == SN.F.threat then
	--	--Are we in a group?
	--		if GetNumGroupMembers() > 4 then
	--			--Check to see if you have any threat
	--			if status ~= nil and threatpct ~= nil then
	--				--Check for high threat
	--				if status == 1 or threatpct > 75 then
	--					--Cycle the threat dump database
	--					for i, spells in pairs(SN.db.profile.threat) do
	--						--See if the spell in the database is for the player's class
	--						if spells.class == select(2, UnitClass("player")) then
	--							local start, dur, _ = GetSpellCooldown(spells.id)
	--							--Check to see if the spell is on cooldown
	--							if spells.order == 1 and dur == 0 then				
	--								--Suggest a threat dump if one is available
	--								frame.value:SetText("High Threat\n\nUse "..name)
	--							elseif spells.order == 2 and dur == 0 then
	--								--Suggest a threat dump if one is available
	--								frame.value:SetText("High Threat\n\nUse "..name)
	--							else
	--								--None available
	--								frame.value:SetText("High Threat\n\nYou're Screwed!")
	--							end
	--						end
	--					end
	--				end
	--			else
	--				frame.value:SetText("")
	--			end
	--		end
	--	end
	--end

	if event == "PLAYER_REGEN_ENABLED" then
		--SN:Debug("I started regening again")
		--After combat empty the dispel text
		if frame == SN.F.dispel then --or SN.F.threat then
			frame.value:SetText("")
		end
	end
	
	if event == "PLAYER_REGEN_DISABLED" then
		SN:StartFight()
	end

	if event == "PLAYER_TARGET_CHANGED" then
		if frame == SN.F.dispel then
			frame.value:SetText("")
		end
	end

	if event == "PLAYER_SPECIALIZATION_CHANGED" then
		--Store the new spec to make sure the powerbar is able to display right
		if frame == SN.F.power then
			frame.spec = GetSpecialization()
		end
	end

	if event == "UNIT_DISPLAYPOWER" then
		--Change the powerbar type
		if select(2, UnitPowerType("player")) == "RAGE" or select(2, UnitPowerType("player")) == "ENERGY" or 
			select(2, UnitPowerType("player")) == "FOCUS" then 

			SN:GetPowerColor()
			frame:SetStatusBarColor(frame.powcolor.r, frame.powcolor.g, frame.powcolor.b, 1)
			frame:SetMinMaxValues(0, (UnitPowerMax("player") > 0) and UnitPowerMax("player") or 100)

			SN.F.powercontainer:Show()
			if SN.db.profile.powerbar.enable then
				SN:PowebarTicks()
			end
		else
			SN.F.powercontainer:Hide()
		end
	end
end
--if event == "GROUP_ROSTER_UPDATE" then
	--	local numGroup = GetNumGroupMembers()
	--	if numGroup > 1 and numGroup < 6 then
	--		for i, numGroup, 1 do
	--			local name, _, _, _, _, _, _, _, _, _, _, combatRole = GetRaidRosterInfo(i)
	--			tinsert(RaidRoster, { i, name, combatRole })
	--		end
	--	end
	--end